# Generated by Snowball 2.0.0 - https://snowballstem.org/

from .basestemmer import BaseStemmer
from .among import Among


class PorterStemmer(BaseStemmer):
    '''
    This class implements the stemming algorithm defined by a snowball script.
    Generated by Snowball 2.0.0 - https://snowballstem.org/
    '''

    a_0 = [
        Among(u"s", -1, 3),
        Among(u"ies", 0, 2),
        Among(u"sses", 0, 1),
        Among(u"ss", 0, -1)
    ]

    a_1 = [
        Among(u"", -1, 3),
        Among(u"bb", 0, 2),
        Among(u"dd", 0, 2),
        Among(u"ff", 0, 2),
        Among(u"gg", 0, 2),
        Among(u"bl", 0, 1),
        Among(u"mm", 0, 2),
        Among(u"nn", 0, 2),
        Among(u"pp", 0, 2),
        Among(u"rr", 0, 2),
        Among(u"at", 0, 1),
        Among(u"tt", 0, 2),
        Among(u"iz", 0, 1)
    ]

    a_2 = [
        Among(u"ed", -1, 2),
        Among(u"eed", 0, 1),
        Among(u"ing", -1, 2)
    ]

    a_3 = [
        Among(u"anci", -1, 3),
        Among(u"enci", -1, 2),
        Among(u"abli", -1, 4),
        Among(u"eli", -1, 6),
        Among(u"alli", -1, 9),
        Among(u"ousli", -1, 11),
        Among(u"entli", -1, 5),
        Among(u"aliti", -1, 9),
        Among(u"biliti", -1, 13),
        Among(u"iviti", -1, 12),
        Among(u"tional", -1, 1),
        Among(u"ational", 10, 8),
        Among(u"alism", -1, 9),
        Among(u"ation", -1, 8),
        Among(u"ization", 13, 7),
        Among(u"izer", -1, 7),
        Among(u"ator", -1, 8),
        Among(u"iveness", -1, 12),
        Among(u"fulness", -1, 10),
        Among(u"ousness", -1, 11)
    ]

    a_4 = [
        Among(u"icate", -1, 2),
        Among(u"ative", -1, 3),
        Among(u"alize", -1, 1),
        Among(u"iciti", -1, 2),
        Among(u"ical", -1, 2),
        Among(u"ful", -1, 3),
        Among(u"ness", -1, 3)
    ]

    a_5 = [
        Among(u"ic", -1, 1),
        Among(u"ance", -1, 1),
        Among(u"ence", -1, 1),
        Among(u"able", -1, 1),
        Among(u"ible", -1, 1),
        Among(u"ate", -1, 1),
        Among(u"ive", -1, 1),
        Among(u"ize", -1, 1),
        Among(u"iti", -1, 1),
        Among(u"al", -1, 1),
        Among(u"ism", -1, 1),
        Among(u"ion", -1, 2),
        Among(u"er", -1, 1),
        Among(u"ous", -1, 1),
        Among(u"ant", -1, 1),
        Among(u"ent", -1, 1),
        Among(u"ment", 15, 1),
        Among(u"ement", 16, 1),
        Among(u"ou", -1, 1)
    ]

    g_v = [17, 65, 16, 1]

    g_v_WXY = [1, 17, 65, 208, 1]

    B_Y_found = False
    I_p2 = 0
    I_p1 = 0

    def __r_shortv(self):
        # (, line 19
        if not self.out_grouping_b(PorterStemmer.g_v_WXY, 89, 121):
            return False
        if not self.in_grouping_b(PorterStemmer.g_v, 97, 121):
            return False
        if not self.out_grouping_b(PorterStemmer.g_v, 97, 121):
            return False
        return True

    def __r_R1(self):
        if not self.I_p1 <= self.cursor:
            return False
        return True

    def __r_R2(self):
        if not self.I_p2 <= self.cursor:
            return False
        return True

    def __r_Step_1a(self):
        # (, line 24
        # [, line 25
        self.ket = self.cursor
        # substring, line 25
        among_var = self.find_among_b(PorterStemmer.a_0)
        if among_var == 0:
            return False
        # ], line 25
        self.bra = self.cursor
        if among_var == 1:
            # (, line 26
            # <-, line 26
            if not self.slice_from(u"ss"):
                return False
        elif among_var == 2:
            # (, line 27
            # <-, line 27
            if not self.slice_from(u"i"):
                return False
        elif among_var == 3:
            # (, line 29
            # delete, line 29
            if not self.slice_del():
                return False

        return True

    def __r_Step_1b(self):
        # (, line 33
        # [, line 34
        self.ket = self.cursor
        # substring, line 34
        among_var = self.find_among_b(PorterStemmer.a_2)
        if among_var == 0:
            return False
        # ], line 34
        self.bra = self.cursor
        if among_var == 1:
            # (, line 35
            # call R1, line 35
            if not self.__r_R1():
                return False
            # <-, line 35
            if not self.slice_from(u"ee"):
                return False
        elif among_var == 2:
            # (, line 37
            # test, line 38
            v_1 = self.limit - self.cursor
            # gopast grouping v, line 38
            if not self.go_out_grouping_b(PorterStemmer.g_v, 97, 121):
                return False
            self.cursor -= 1
            self.cursor = self.limit - v_1
            # delete, line 38
            if not self.slice_del():
                return False

            # test, line 39
            v_2 = self.limit - self.cursor
            # substring, line 39
            among_var = self.find_among_b(PorterStemmer.a_1)
            if among_var == 0:
                return False
            self.cursor = self.limit - v_2
            if among_var == 1:
                # (, line 41
                # <+, line 41
                c = self.cursor
                self.insert(self.cursor, self.cursor, u"e")
                self.cursor = c
            elif among_var == 2:
                # (, line 44
                # [, line 44
                self.ket = self.cursor
                # next, line 44
                if self.cursor <= self.limit_backward:
                    return False
                self.cursor -= 1
                # ], line 44
                self.bra = self.cursor
                # delete, line 44
                if not self.slice_del():
                    return False

            elif among_var == 3:
                # (, line 45
                # atmark, line 45
                if self.cursor != self.I_p1:
                    return False
                # test, line 45
                v_3 = self.limit - self.cursor
                # call shortv, line 45
                if not self.__r_shortv():
                    return False
                self.cursor = self.limit - v_3
                # <+, line 45
                c = self.cursor
                self.insert(self.cursor, self.cursor, u"e")
                self.cursor = c
        return True

    def __r_Step_1c(self):
        # (, line 51
        # [, line 52
        self.ket = self.cursor
        # or, line 52
        try:
            v_1 = self.limit - self.cursor
            try:
                # literal, line 52
                if not self.eq_s_b(u"y"):
                    raise lab1()
                raise lab0()
            except lab1: pass
            self.cursor = self.limit - v_1
            # literal, line 52
            if not self.eq_s_b(u"Y"):
                return False
        except lab0: pass
        # ], line 52
        self.bra = self.cursor
        # gopast grouping v, line 53
        if not self.go_out_grouping_b(PorterStemmer.g_v, 97, 121):
            return False
        self.cursor -= 1
        # <-, line 54
        if not self.slice_from(u"i"):
            return False
        return True

    def __r_Step_2(self):
        # (, line 57
        # [, line 58
        self.ket = self.cursor
        # substring, line 58
        among_var = self.find_among_b(PorterStemmer.a_3)
        if among_var == 0:
            return False
        # ], line 58
        self.bra = self.cursor
        # call R1, line 58
        if not self.__r_R1():
            return False
        if among_var == 1:
            # (, line 59
            # <-, line 59
            if not self.slice_from(u"tion"):
                return False
        elif among_var == 2:
            # (, line 60
            # <-, line 60
            if not self.slice_from(u"ence"):
                return False
        elif among_var == 3:
            # (, line 61
            # <-, line 61
            if not self.slice_from(u"ance"):
                return False
        elif among_var == 4:
            # (, line 62
            # <-, line 62
            if not self.slice_from(u"able"):
                return False
        elif among_var == 5:
            # (, line 63
            # <-, line 63
            if not self.slice_from(u"ent"):
                return False
        elif among_var == 6:
            # (, line 64
            # <-, line 64
            if not self.slice_from(u"e"):
                return False
        elif among_var == 7:
            # (, line 66
            # <-, line 66
            if not self.slice_from(u"ize"):
                return False
        elif among_var == 8:
            # (, line 68
            # <-, line 68
            if not self.slice_from(u"ate"):
                return False
        elif among_var == 9:
            # (, line 69
            # <-, line 69
            if not self.slice_from(u"al"):
                return False
        elif among_var == 10:
            # (, line 72
            # <-, line 72
            if not self.slice_from(u"ful"):
                return False
        elif among_var == 11:
            # (, line 74
            # <-, line 74
            if not self.slice_from(u"ous"):
                return False
        elif among_var == 12:
            # (, line 76
            # <-, line 76
            if not self.slice_from(u"ive"):
                return False
        elif among_var == 13:
            # (, line 77
            # <-, line 77
            if not self.slice_from(u"ble"):
                return False
        return True

    def __r_Step_3(self):
        # (, line 81
        # [, line 82
        self.ket = self.cursor
        # substring, line 82
        among_var = self.find_among_b(PorterStemmer.a_4)
        if among_var == 0:
            return False
        # ], line 82
        self.bra = self.cursor
        # call R1, line 82
        if not self.__r_R1():
            return False
        if among_var == 1:
            # (, line 83
            # <-, line 83
            if not self.slice_from(u"al"):
                return False
        elif among_var == 2:
            # (, line 85
            # <-, line 85
            if not self.slice_from(u"ic"):
                return False
        elif among_var == 3:
            # (, line 87
            # delete, line 87
            if not self.slice_del():
                return False

        return True

    def __r_Step_4(self):
        # (, line 91
        # [, line 92
        self.ket = self.cursor
        # substring, line 92
        among_var = self.find_among_b(PorterStemmer.a_5)
        if among_var == 0:
            return False
        # ], line 92
        self.bra = self.cursor
        # call R2, line 92
        if not self.__r_R2():
            return False
        if among_var == 1:
            # (, line 95
            # delete, line 95
            if not self.slice_del():
                return False

        elif among_var == 2:
            # (, line 96
            # or, line 96
            try:
                v_1 = self.limit - self.cursor
                try:
                    # literal, line 96
                    if not self.eq_s_b(u"s"):
                        raise lab1()
                    raise lab0()
                except lab1: pass
                self.cursor = self.limit - v_1
                # literal, line 96
                if not self.eq_s_b(u"t"):
                    return False
            except lab0: pass
            # delete, line 96
            if not self.slice_del():
                return False

        return True

    def __r_Step_5a(self):
        # (, line 100
        # [, line 101
        self.ket = self.cursor
        # literal, line 101
        if not self.eq_s_b(u"e"):
            return False
        # ], line 101
        self.bra = self.cursor
        # or, line 102
        try:
            v_1 = self.limit - self.cursor
            try:
                # call R2, line 102
                if not self.__r_R2():
                    raise lab1()
                raise lab0()
            except lab1: pass
            self.cursor = self.limit - v_1
            # (, line 102
            # call R1, line 102
            if not self.__r_R1():
                return False
            # not, line 102
            v_2 = self.limit - self.cursor
            try:
                # call shortv, line 102
                if not self.__r_shortv():
                    raise lab2()
                return False
            except lab2: pass
            self.cursor = self.limit - v_2
        except lab0: pass
        # delete, line 103
        if not self.slice_del():
            return False

        return True

    def __r_Step_5b(self):
        # (, line 106
        # [, line 107
        self.ket = self.cursor
        # literal, line 107
        if not self.eq_s_b(u"l"):
            return False
        # ], line 107
        self.bra = self.cursor
        # call R2, line 108
        if not self.__r_R2():
            return False
        # literal, line 108
        if not self.eq_s_b(u"l"):
            return False
        # delete, line 109
        if not self.slice_del():
            return False

        return True

    def _stem(self):
        # (, line 113
        # unset Y_found, line 115
        self.B_Y_found = False
        # do, line 116
        v_1 = self.cursor
        try:
            # (, line 116
            # [, line 116
            self.bra = self.cursor
            # literal, line 116
            if not self.eq_s(u"y"):
                raise lab0()
            # ], line 116
            self.ket = self.cursor
            # <-, line 116
            if not self.slice_from(u"Y"):
                return False
            # set Y_found, line 116
            self.B_Y_found = True
        except lab0: pass
        self.cursor = v_1
        # do, line 117
        v_2 = self.cursor
        try:
            # repeat, line 117
            while True:
                v_3 = self.cursor
                try:
                    # (, line 117
                    # goto, line 117
                    try:
                        while True:
                            v_4 = self.cursor
                            try:
                                # (, line 117
                                if not self.in_grouping(PorterStemmer.g_v, 97, 121):
                                    raise lab4()
                                # [, line 117
                                self.bra = self.cursor
                                # literal, line 117
                                if not self.eq_s(u"y"):
                                    raise lab4()
                                # ], line 117
                                self.ket = self.cursor
                                self.cursor = v_4
                                raise lab3()
                            except lab4: pass
                            self.cursor = v_4
                            if self.cursor >= self.limit:
                                raise lab2()
                            self.cursor += 1
                    except lab3: pass
                    # <-, line 117
                    if not self.slice_from(u"Y"):
                        return False
                    # set Y_found, line 117
                    self.B_Y_found = True
                    continue
                except lab2: pass
                self.cursor = v_3
                break
        except lab1: pass
        self.cursor = v_2
        self.I_p1 = self.limit
        self.I_p2 = self.limit
        # do, line 121
        v_5 = self.cursor
        try:
            # (, line 121
            # gopast grouping v, line 122
            if not self.go_out_grouping(PorterStemmer.g_v, 97, 121):
                raise lab5()
            self.cursor += 1
            # gopast non v, line 122
            if not self.go_in_grouping(PorterStemmer.g_v, 97, 121):
                raise lab5()
            self.cursor += 1
            # setmark p1, line 122
            self.I_p1 = self.cursor
            # gopast grouping v, line 123
            if not self.go_out_grouping(PorterStemmer.g_v, 97, 121):
                raise lab5()
            self.cursor += 1
            # gopast non v, line 123
            if not self.go_in_grouping(PorterStemmer.g_v, 97, 121):
                raise lab5()
            self.cursor += 1
            # setmark p2, line 123
            self.I_p2 = self.cursor
        except lab5: pass
        self.cursor = v_5
        # backwards, line 126
        self.limit_backward = self.cursor
        self.cursor = self.limit
        # (, line 126
        # do, line 127
        v_6 = self.limit - self.cursor
        # call Step_1a, line 127
        self.__r_Step_1a()
        self.cursor = self.limit - v_6
        # do, line 128
        v_7 = self.limit - self.cursor
        # call Step_1b, line 128
        self.__r_Step_1b()
        self.cursor = self.limit - v_7
        # do, line 129
        v_8 = self.limit - self.cursor
        # call Step_1c, line 129
        self.__r_Step_1c()
        self.cursor = self.limit - v_8
        # do, line 130
        v_9 = self.limit - self.cursor
        # call Step_2, line 130
        self.__r_Step_2()
        self.cursor = self.limit - v_9
        # do, line 131
        v_10 = self.limit - self.cursor
        # call Step_3, line 131
        self.__r_Step_3()
        self.cursor = self.limit - v_10
        # do, line 132
        v_11 = self.limit - self.cursor
        # call Step_4, line 132
        self.__r_Step_4()
        self.cursor = self.limit - v_11
        # do, line 133
        v_12 = self.limit - self.cursor
        # call Step_5a, line 133
        self.__r_Step_5a()
        self.cursor = self.limit - v_12
        # do, line 134
        v_13 = self.limit - self.cursor
        # call Step_5b, line 134
        self.__r_Step_5b()
        self.cursor = self.limit - v_13
        self.cursor = self.limit_backward
        # do, line 137
        v_14 = self.cursor
        try:
            # (, line 137
            # Boolean test Y_found, line 137
            if not self.B_Y_found:
                raise lab6()
            # repeat, line 137
            while True:
                v_15 = self.cursor
                try:
                    # (, line 137
                    # goto, line 137
                    try:
                        while True:
                            v_16 = self.cursor
                            try:
                                # (, line 137
                                # [, line 137
                                self.bra = self.cursor
                                # literal, line 137
                                if not self.eq_s(u"Y"):
                                    raise lab9()
                                # ], line 137
                                self.ket = self.cursor
                                self.cursor = v_16
                                raise lab8()
                            except lab9: pass
                            self.cursor = v_16
                            if self.cursor >= self.limit:
                                raise lab7()
                            self.cursor += 1
                    except lab8: pass
                    # <-, line 137
                    if not self.slice_from(u"y"):
                        return False
                    continue
                except lab7: pass
                self.cursor = v_15
                break
        except lab6: pass
        self.cursor = v_14
        return True


class lab0(BaseException): pass


class lab1(BaseException): pass


class lab2(BaseException): pass


class lab3(BaseException): pass


class lab4(BaseException): pass


class lab5(BaseException): pass


class lab6(BaseException): pass


class lab7(BaseException): pass


class lab8(BaseException): pass


class lab9(BaseException): pass
